isEmpty(INSTALL_ROOT) {
    INSTALL_ROOT = /runtime
}

# installation target dir
isEmpty(prefix) {
    prefix = $${INSTALL_ROOT}
}

# installation target dir
isEmpty(CUMBIA_ROOT) {
    CUMBIA_ROOT = $${prefix}
}

MAKEFILE=Makefile.qmake

QT       += widgets svg opengl

CUMBIA_QTCONTROLS_NG_INCLUDES=$${INSTALL_ROOT}/include/cumbia-qtcontrols-ng
CUMBIA_QTCONTROLS_NG_SHARE=$${INSTALL_ROOT}/share/cumbia-qtcontrols-ng
CUMBIA_QTCONTROLS_NG_LIBDIR=$${INSTALL_ROOT}/lib
CUMBIA_QTCONTROLS_NG_DOCDIR=$${INSTALL_ROOT}/share/doc/cumbia-qtcontrols-ng

# The name of the library
cumbia_qtcontrols_ng_LIB=cumbia-qtcontrols-ng


VERSION_HEX = 0x020309
VERSION = 2.3.9

DEFINES += CUMBIA_QTCONTROLS_NG_VERSION_STR=\"\\\"$${VERSION}\\\"\" \
    CUMBIA_QTCONTROLS_NG_VERSION=$${VERSION_HEX}

MOC_DIR=moc
OBJECTS_DIR=objs


exists($${CUMBIA_ROOT}/include/cumbia) {
    INCLUDEPATH += $${CUMBIA_ROOT}/include/cumbia
    LIBS += -L$${CUMBIA_ROOT}/lib -lcumbia
} else {
    error("cumbia installation not found under $${CUMBIA_ROOT}")
}
# libs at this point contain $${INSTALL_ROOT}/lib

exists($${CUMBIA_ROOT}/include/cumbia-qtcontrols/cumbia-qtcontrols.pri) {
    INCLUDEPATH += $${CUMBIA_ROOT}/include/cumbia-qtcontrols
    LIBS += -lcumbia-qtcontrols
} else {
    error("cumbia-qtcontrols installation not found under $${CUMBIA_ROOT}")
}

CONFIG += link_pkgconfig
packagesExist(qwt){
    PKGCONFIG += qwt
}
# qwt for qt6
else:packagesExist(Qt6Qwt6){
    PKGCONFIG += Qt6Qwt6
    message("qwt6 for QT6")
}
else:packagesExist(Qt5Qwt6){
    PKGCONFIG += Qt5Qwt6
}  else {
    warning("cumbia-qtcontrols.pri: no pkg-config file found for either qwt or Qt5Qwt6")
    warning("cumbia-qtcontrols.pri: export PKG_CONFIG_PATH=/usr/path/to/qwt/lib/pkgconfig if you want to enable pkg-config for qwt")
    warning("cumbia-qtcontrols.pri: if you build and install qwt from sources, be sure to uncomment/enable ")
    warning("cumbia-qtcontrols.pri: QWT_CONFIG     += QwtPkgConfig in qwtconfig.pri qwt project configuration file")
}

greaterThan(QT_MAJOR_VERSION, 5) {
    QT += openglwidgets
}

LIBS += -L$${INSTALL_ROOT}/lib -l$${cumbia_qtcontrols_ng_LIB}

DISTFILES += \
    $$PWD/cumbia-qtcontrols-ng.md

