#ifndef Gauge_H
#define Gauge_H

#include <QWidget>
#include <qframe.h>
#include <qulogimpl.h>

namespace Ui {
class Gauge;
}

class GaugeDrawable;

class Frame : public QFrame {
    Q_OBJECT
public:
    Frame(QWidget *parent) : QFrame(parent) {}
    void setDrawables(const QVector<GaugeDrawable *>& dras);
    void paintEvent(QPaintEvent *e);

    QVector<GaugeDrawable *> m_dras;
};

class Gauge : public QWidget
{
    Q_OBJECT

public:
    explicit Gauge(QWidget *parent = 0);
    ~Gauge();

public slots:
    void onTimeout();
    void onSpinValueChanged(double v);
    void onCheckBoxToggled(bool b);
    void onCurrentSelChanged(const QString& t);
    void onSliderChanged(int v);
    void onRefreshEnabled(bool en);
    void onLineEditTextChanged(const QString& t);
private:
    Ui::Gauge *ui;
    unsigned long m_cnt;
};

#endif // Gauge_H
