#ifndef QUCIRCULARPLOTDISKSECTOR_H
#define QUCIRCULARPLOTDISKSECTOR_H

#include <drawable_i.h>
#include <QStringList>
#include <QVector>
#include <QColor>
#include <QFont>
#include <QSizeF>

class QuCircularPlotDiskSector_P;
class QPointF;

struct ds_paint {
    QVector<QColor> sections_background;
    QColor sections_outline;
    QColor background;
    QColor text;
    QFont font;
};

struct ds_sections {
    QStringList names;

};

struct ds_geom {
    float text_distance {-1.0};
    float draw_from {-1.0};
    float draw_to {-1.0};
};

struct qucircularplotdisksector_attributes {
    struct ds_paint paint;
    struct ds_sections sections;
    struct ds_geom geom;
};

class QuCircularPlotDiskSector : public Drawable_I
{
public:
    QuCircularPlotDiskSector();
    virtual ~QuCircularPlotDiskSector();
    qucircularplotdisksector_attributes attributes;

    void setSections(const QStringList& names);
    void setSectionColors(const QVector<QColor>& c);
    void setBackgroundColor(const QColor& c);
    void setTextDist(const float& f);

    QVector<QColor> sectionColors() const;
    QStringList sections() const;
    QColor backgroundColor() const;
    float textDist() const;

    int index(const QPointF& pt);

    void setDrawFrom(float from);
    void setDrawTo(float to);


 // Drawable_I interfacepublic:
    bool scales();
    int z() const;
    void draw(QPainter *p, const QRectF &rect);
    QPointF relativeCenter() const;
    QSizeF relativeSize() const;

private:
    QuCircularPlotDiskSector_P *d;

public:
};

#endif // QUCIRCULARPLOTDISKSECTOR_H
